1.两数之和(简单)

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。
你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。

示例:

给定 nums = [2, 7, 11, 15], target = 9
因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/two-sum

思路:

一次哈希,在迭代时将元素添加到表中,还会回头检查表中是否存在当前元素所对应的目标元素,如果已经存在,表示已经找到,并立即返回

回看记录200627

添加go代码

代码:

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
class Solution {
public int[] twoSum(int[] nums, int target) {
int n = nums.length;
Map<Integer,Integer> map = new HashMap<>();
for(int i=0;i<n;i++)
map.put(nums[i],i);
for(int i=0;i<n;i++){
int res = target-nums[i];
if(map.containsKey(res) && map.get(res)!=i){
return new int[]{i,map.get(res)};
}
}
return new int[]{-1,-1};
}
}
//一次哈希
class Solution {
public int[] twoSum(int[] nums, int target) {
int n = nums.length;
Map<Integer,Integer> map = new HashMap<>();

for(int i=0;i<n;i++){
int res = target-nums[i];
if(map.containsKey(res) && map.get(res)!=i){
return new int[]{i,map.get(res)};
}
map.put(nums[i],i);
}
return new int[]{-1,-1};
}
}

代码:

1
2
3
4
5
6
7
8
9
10
func twoSum(nums []int, target int) []int {
var m = make(map[int]int)//value,key
for i,v:=range nums{
if k,ok :=m[target-v];ok{
return []int{k,i}
}
m[v] = i
}
return nil
}